#include "InterfaceHeader.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <check.h>
#include <pthread.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>

/*
 * 
 */

struct argsThread {
    int argc;
    int length;
    int * arrayC;
    FILE * fin;
    FILE * fout;
    char **argv;
};
typedef struct argsThread ArgsThread;

int * finishedThread;

void * threadWrapper(void * args) {
    ArgsThread * pointerArgs = args;
    GRAFT_INTERFACE (NULL, -1, NULL, NULL, -1);
    *finishedThread = 1;
}

int compare_two_binary_files(FILE *fp1, FILE *fp2) {
    char ch1, ch2;
    int flag = 0;
    while (((ch1 = fgetc(fp1)) != EOF) &&((ch2 = fgetc(fp2)) != EOF)) {
        if (ch1 == ch2) {
            flag = 1;
            continue;
        } else {
            fseek(fp1, -1, SEEK_CUR);
            flag = 0;
            break;
        }
    }

	if(ch1 == EOF){

		ch2 = fgetc(fp2);
	}

    if ( (ch1 != EOF) || (ch2 != EOF)) {
        flag = 0;
    }

    if (flag == 0) {
        return 1;
        //printf("Two files are not equal :  byte poistion at which two files differ is %d\n", ftell(fp1) + 1);

    } else {
        return 0;
        //printf("Two files are Equal\n ", ftell(fp1) + 1);
    }

}

START_TEST(test_1) {

    char * currentResultsOutput = "/home/alex/NetBeansProjects/TESTgOto/testCURL.out";
    char * oracle = "/home/alex/NetBeansProjects/TESTgOto/webServerIndexOracle.out";
    
    //clean up the file
    FILE * cleanUp = fopen(currentResultsOutput, "w");
    fprintf(cleanUp,"\n");
    fclose(cleanUp);

    FILE *fin = fopen("/home/alex/NetBeansProjects/HostExample/input.in", "r");
    FILE *fout = fopen("output.out", "w");
    int *arrayC;
    int length;

    fscanf(fin, "%d", & length);
    arrayC = (int *) malloc((length + 1) * sizeof (int));
    for (int i = 0; i < length; i++) {
        fscanf(fin, "%d", & arrayC [i]);
    }
    for (int i = 0; i < length; i++) {
        fprintf(fout, "%d ", arrayC [i]);
    }
    pthread_t inc_x_thread;
    int TRANSPLANT_RESULT;
    ArgsThread arguments;
    arguments.argc = 1;
    arguments.argv = NULL;
    arguments.length = length;
    arguments.arrayC = arrayC;
    arguments.fout = fout;
    arguments.fin = fin;
    finalAddress = mmap(NULL, sizeof *finalAddress, PROT_READ | PROT_WRITE,
            MAP_SHARED | MAP_ANONYMOUS, -1, 0);
    finishedThread = mmap(NULL, sizeof *finishedThread, PROT_READ | PROT_WRITE,
            MAP_SHARED | MAP_ANONYMOUS, -1, 0);
    *finalAddress = -1;
    * finishedThread = 0;
    if (pthread_create(&inc_x_thread, NULL, threadWrapper, &arguments)) {
        fprintf(stderr, "Error creating thread\n");
        return;
    }
    //sleep(15);
    int passed = 0;
    while (!passed && !(*finishedThread)) {
        sleep(2);
        char * commandString = (char *) malloc(1000 * sizeof (char));

        sprintf(commandString, "curl http://0.0.0.0:%u/ > %s",
                *finalAddress, currentResultsOutput);
        printf("%s\n", commandString);
        int commandResults = system(commandString);
        //if(commandResults != -1){

        FILE * resultsFile = fopen(currentResultsOutput, "r");
        FILE * oracleFile = fopen(oracle, "r");

        if (!compare_two_binary_files(resultsFile, oracleFile)) {
            passed = 1;
            ck_assert_int_eq(5, 5);
            printf("PASSED!\n");
        }
    }
    if (*finishedThread) {
        ck_abort();
    }
}

END_TEST







START_TEST(test_2) {
    char * currentResultsOutput = "/home/alex/NetBeansProjects/TESTgOto/testCURL.out";
    char * oracle = "/home/alex/NetBeansProjects/TESTgOto/webServerHomePageOracle.out";
    
    //clean up the file
    FILE * cleanUp = fopen(currentResultsOutput, "w");
    fprintf(cleanUp,"\n");
    fclose(cleanUp);
    
    
    FILE *fin = fopen("/home/alex/NetBeansProjects/HostExample/input.in", "r");
    FILE *fout = fopen("output.out", "w");
    int *arrayC;
    int length;
    fscanf(fin, "%d", & length);
    arrayC = (int *) malloc((length + 1) * sizeof (int));
    for (int i = 0; i < length; i++) {
        fscanf(fin, "%d", & arrayC [i]);
    }
    for (int i = 0; i < length; i++) {
        fprintf(fout, "%d ", arrayC [i]);
    }
    pthread_t inc_x_thread;
    int TRANSPLANT_RESULT;
    ArgsThread arguments;
    arguments.argc = 1;
    arguments.argv = NULL;
    arguments.length = length;
    arguments.arrayC = arrayC;
    arguments.fout = fout;
    arguments.fin = fin;
    finalAddress = mmap(NULL, sizeof *finalAddress, PROT_READ | PROT_WRITE,
            MAP_SHARED | MAP_ANONYMOUS, -1, 0);
    finishedThread = mmap(NULL, sizeof *finishedThread, PROT_READ | PROT_WRITE,
            MAP_SHARED | MAP_ANONYMOUS, -1, 0);
    *finalAddress = -1;
    * finishedThread = 0;
    if (pthread_create(&inc_x_thread, NULL, threadWrapper, &arguments)) {
        fprintf(stderr, "Error creating thread\n");
        return;
    }
    //sleep(15);
    int passed = 0;
    while (!passed && !(*finishedThread)) {
        sleep(2);
        char * commandString = (char *) malloc(1000 * sizeof (char));

        sprintf(commandString, "curl http://0.0.0.0:%u/helloworld.html > %s",
                *finalAddress, currentResultsOutput);
        printf("%s\n", commandString);
        int commandResults = system(commandString);
        //if(commandResults != -1){

        FILE * resultsFile = fopen(currentResultsOutput, "r");
        FILE * oracleFile = fopen(oracle, "r");

        if (!compare_two_binary_files(resultsFile, oracleFile)) {
            passed = 1;
            ck_assert_int_eq(5, 5);
            printf("PASSED!\n");
        }
    }

    if (*finishedThread) {
        ck_abort();
    }

}

END_TEST


START_TEST(test_3) {
    char * currentResultsOutput = "/home/alex/NetBeansProjects/TESTgOto/testCURL.out";
    char * oracle = "/home/alex/NetBeansProjects/TESTgOto/testCURLWrongReq.out";
    //clean up the file
    FILE * cleanUp = fopen(currentResultsOutput, "w");
    fprintf(cleanUp, "\n");
    fclose(cleanUp);
    pthread_t inc_x_thread;
    int TRANSPLANT_RESULT;
    finalAddress = mmap(NULL, sizeof *finalAddress, PROT_READ | PROT_WRITE,
            MAP_SHARED | MAP_ANONYMOUS, -1, 0);
    finishedThread = mmap(NULL, sizeof *finishedThread, PROT_READ | PROT_WRITE,
            MAP_SHARED | MAP_ANONYMOUS, -1, 0);
    *finalAddress = -1;
    * finishedThread = 0;
    if (pthread_create(&inc_x_thread, NULL, threadWrapper, NULL)) {
        fprintf(stderr, "Error creating thread\n");
        return;
    }
    int passed = 0;
    while (!passed && !(*finishedThread)) {
        sleep(2);
        char * commandString = (char *) malloc(1000 * sizeof (char));
        sprintf(commandString, "curl http://0.0.0.0:%u/nothing.html > %s",
                *finalAddress, currentResultsOutput);
        printf("%s\n", commandString);
        int commandResults = system(commandString);
        FILE * resultsFile = fopen(currentResultsOutput, "r");
        FILE * oracleFile = fopen(oracle, "r");
        if (!compare_two_binary_files(resultsFile, oracleFile)) {
            passed = 1;
            ck_assert_int_eq(5, 5);
            printf("PASSED!\n");
        }
    }
    if (*finishedThread) {
        ck_abort();
    }
}

END_TEST



Suite *
money_suite(void) {
    Suite *s = suite_create("GenTransSuite");
    // Core test case 
    TCase *tc_core = tcase_create("Core");
    tcase_set_timeout(tc_core, 15);
    tcase_add_test(tc_core, test_1);
    tcase_add_test(tc_core, test_2);
    tcase_add_test(tc_core, test_3);
    suite_add_tcase(s, tc_core);
    return s;
}

int main(int argc, char** argv) {
    int number_failed;
    Suite *s = money_suite();
    SRunner *sr = srunner_create(s);
    srunner_run_all(sr, CK_SILENT);

    printf("\n\n");

    srunner_print(sr, CK_NORMAL);

    number_failed = srunner_ntests_failed(sr);
    srunner_free(sr);
    return (number_failed == 0) ? EXIT_SUCCESS : EXIT_FAILURE;
    //  return (EXIT_SUCCESS);
}

